import numpy as np
from sklearn.model_selection import train_test_split
from sklearn.neighbors import KNeighborsClassifier
import matplotlib.pyplot as plt
from matplotlib.colors import ListedColormap

D = np.loadtxt( "datos.txt" )
X = D[:,0:2]
y = D[:,2]

# El modelo de la red
W2 = np.array([[ 2.03715544, -0.8804249 ,  0.22900385,  1.54924213],
       [-1.30107132, -0.92889057, -1.85402565, -0.06437703]])

W3 = np.array([[-1.612149  ,  2.19449429, -1.81507881],
       [ 2.58115393, -1.17879013, -0.23216221],
       [ 3.0665629 ,  1.33073009, -4.52390351],
       [-2.02299035,  1.22794199, -0.88589005]])

vs2 = np.array([-0.56183526, -1.71757552,  0.55008684, -0.17444643])
vs3 = np.array([-1.24666627,  0.11341611,  0.11469488])

def evalua( x ) :
	#           1x2 2x12 = 1x12  
	s2 = np.tanh( x @ W2 + vs2 )
	s3 = s2 @ W3 + vs3 

	# print( s3.shape )

	# Calculamos la función softmax
	# suma = np.exp( s3[0,0] - m ) + np.exp( s3[0,1] - m ) + np.exp( s3[0,2] - m )
	m = np.max( s3 )
	suma = np.sum( np.exp( s3 - m ) )
	vz = np.exp( s3 - m )/suma
	k = np.argmax( vz )

	return k

#########################################################################

X_entrena, X_prueba, y_entrena, y_prueba = train_test_split( X, y, random_state=2 )

# Hacemos la gráfica de la superficie de decisión
# En x,y \in [-2,2]
n = 100
vx = np.linspace( -5, 4, n )
vy = np.linspace( -6, 6.5, n )

x, y = np.meshgrid( vx, vy )
Z = np.zeros( (n,n) )

va = np.zeros( (1,2) )

for i in range(n):
	for j in range(n):
		va[0,0]  = x[j,i]
		va[0,1]  = y[j,i]
		Z[j,i] = evalua( va )


fig, ax = plt.subplots()

cm = plt.cm.RdBu
cm_bright = ListedColormap(['#FF0000', '#0000FF'])

ax.contourf( x, y, Z, cmap=cm, alpha=.8 )
ax.set_aspect(1)
# ax.scatter( decision.Vs[:,0], decision.Vs[:,1] )
# ax.set_xticks(())
# ax.set_yticks(())
ax.scatter( X_entrena[:,0], X_entrena[:,1], c=y_entrena, cmap=cm_bright, edgecolors='k' )
ax.scatter( X_prueba[:,0], X_prueba[:,1], marker='x', c=y_prueba, cmap=cm_bright, edgecolors='k' )

plt.show( )

