import numpy as np
from sklearn.model_selection import train_test_split
from sklearn.neural_network import MLPClassifier

D = np.loadtxt( "datos.txt" )
print( D.shape )

X = D[:,0:2]
y = D[:,2]

print( X.shape )

# Separamos los datos en datos de entrenamiento
# y datos de prueba
#

X_entrena, X_prueba, y_entrena, y_prueba = train_test_split( X, y, random_state=2 )

clasificador = MLPClassifier( hidden_layer_sizes=(4,), activation='tanh', solver='lbfgs', random_state=2 )
clasificador.fit( X_entrena, y_entrena )

exac_entrena = clasificador.score( X_entrena, y_entrena )
print( exac_entrena )

exac_prueba = clasificador.score( X_prueba, y_prueba )
print( exac_prueba )

predice = clasificador.predict( X_prueba )
print( predice )
print( y_prueba )

print( clasificador.classes_ )
print( clasificador.coefs_ )
print( clasificador.intercepts_ )
print( clasificador.n_layers_ )
print( clasificador.n_outputs_ )
print( clasificador.out_activation_ )

# print( X_prueba )
